Const gmPlaying = 1
Const gmInstructions = 2
Const gmGameOver= 3
Const gmRoundOver= 4
Const gmAnnouncingRound = 5

Global GameMode=gmInstructions

Const GribblyCount = 20 
Global CurrentRound
Global Counter
Global RoundCountDown

Global RoundWindowY#
Global RoundWindowDy#
Const Maxround = 3

Dim DarkStats(MaxRound)
Dim LightStats(MaxRound)

Function CalculateWinner()
	LightScore = 0
	DarkScore = 0
	For I = 1 To MaxRound 
		If DarkStats(I) > LightStats(I) Then DarkScore=DarkScore+1
		If DarkStats(I) < LightStats(I) Then LightScore=LightScore+1		
	Next
	Result = Neutral
	If LightScore > DarkScore Then Result = Black
	If DarkScore > LightScore Then Result = White
	Return result 
End Function

Global Winner 

Function MovePlayCycle()
		If KeyDown( 74 )=True Then zoom=zoom - 0.05
		If KeyDown( 78 )=True Then zoom=zoom + 0.05

		UpdatePlayers()
		D# = PlayerDistance(Player1,Player2)/350
		;If D > 2.0 Then D = 2.0
		If D < 0.0 Then D = 0.0
		Zoom=2.4-D
		If Zoom < 0.6 Then zoom = 0.6
		setCameraZoom(Zoom)
		PositionEntity GameCamera,(Player1\X+Player2\X)/2,(Player1\Y+Player2\Y)/2,-1
		For I = 0 To 2  ;bullets do 3 microsteps rather than moving fast
			MoveBullets()
			FreeDeadBullets()
			MoveGribblies(I=0)
			FreeDeadGribblies()
		Next
		HandleInputs((Counter And 7) = 0)

		
		MoveExplosions()
		UpdateWorld

End Function

Function MouseInRect(RLeft,RTop,RRight,RBottom)
	Mx=MouseX()
	My=MouseY()
	Return  (MX>RLeft) And (My > RTop) And (Mx <=RRight) And (MY <=RBottom) 
End Function

Function MoveGame()
	Select GameMode
	
	Case gmPlaying
		MovePlayCycle()
		ProcessInputs(Player1,BlackInput)
		ProcessInputs(Player2,WhiteInput)
		If (BlackGribbliesInWild + WhiteGribbliesInWild)=0 Then
			DarkStats(CurrentRound)= BlackGribbliesHome
			LightStats(CurrentRound)=WhiteGribbliesHome
			If CurrentRound = 3 Then
				GameMode = gmGameOver
				Winner= CalculateWinner()
			Else
				GameMode = gmRoundOver
			End If
		End If
	Case  gmInstructions
		buttonclicked = MouseInRect(456,521,456+83,521+51) And MouseHit(1)
		If KeyHit(57) Or KeyHit (28) Or ButtonClicked Then
			CurrentRound = 1		
			InitializeLevel()
		End If
	Case gmAnnouncingRound
		MovePlayCycle()
		If roundCountDown > 0 Then
			RoundCountDown = RoundCountDown - 1
		Else		
			RoundWindowY=RoundWindowY+RoundWindowDY
			roundWindowDy=8		
			If RoundWindowY > 600 Then GameMode = gmPlaying	
		End If 
	Case gmRoundOver
		ButtonClicked =MouseInRect(466,495,466+83,495+51) And MouseHit(1)
		If KeyHit(57) Or KeyHit (28) Or ButtonClicked Then
			CurrentRound = CurrentRound + 1		
			InitializeLevel()
		End If
	Case gmGameOver
		ButtonClicked =MouseInRect(466,495,466+83,495+51) And MouseHit(1)
		If KeyHit(57) Or KeyHit (28) Or ButtonClicked Then
			GameMode=gmInstructions
		End If

	End Select

End Function


Function InitializeLevel()
	RoundWindowY=0
	RoundWindowDy=0
	SetBuffer FrontBuffer()
	DrawImage GeneratingLevel,368,289
	GameMode = gmAnnouncingRound
	RoundCountDown = 50
	FreeAllGribblies()
	DestroyAllBullets()
	
	SetBuffer WorldBuffer
	
	
	MakeworldPattern()
	
	For I = 0 To 0
		Color 255,255,255
		Oval(Rand(1024),Rand(1024),Rand(15,20),Rand(15,20))
		Color 0,0,0
		Oval(Rand(1024),Rand(1024),Rand(15,20),Rand(15,20))
	Next
	
	
	
	Color 255,255,255
	Oval(128-64,128-64,128,128)
	
	Color 0,0,0
	Oval(896-64,768+64,128,128)
	
	SetBuffer(BackBuffer())
	
	UpdateWorldTexture()
	
	For I = 1 To GribblyCount
		AddGribbly(Black,128,128)
		AddGribbly(White,896,896)
	Next
	RespawnPlayer(Player1)
	RespawnPlayer(Player2)	
End Function